local mod = ...



-- Asset -------------------------------------------------------------------------------------
mod:registerAssetId("models/Security1.fbx/Prefab/HutPart", "PREFAB_SECURITY_PATROLHUT1")
mod:registerAssetId("models/Security1.fbx/Prefab/HutConstruction", "PREFAB_CONSTR_SECURITY_PATROLHUT1")
mod:registerAssetId("models/Security1.fbx/Prefab/PatrolPart/PatrolPoint", "PREFAB_SECURITY_PATROLPOINT1")
mod:registerAssetId("models/Security1.fbx/Prefab/GuardPart/GuardPoint", "PREFAB_SECURITY_GUARDPOINT1")

mod:registerAssetId("models/Security2.fbx/Prefab/PlatformPart", "PREFAB_SECURITY_CRIER1")
mod:registerAssetId("models/Security2.fbx/Prefab/PlatformConstruction", "PREFAB_CONSTR_SECURITY_CRIER1")

mod:registerAssetId("models/Security1.fbx/Prefab/CharacterPart/PatrolFemale", "PREFAB_SECURITY_CHARACTER_PATROLFEMALE1")
mod:registerAssetId("models/Security1.fbx/Prefab/CharacterPart/PatrolMale", "PREFAB_SECURITY_CHARACTER_PATROLMALE1")

mod:registerAssetId("models/Security1.fbx/Prefab/CharacterPart/GuardFemale", "PREFAB_SECURITY_CHARACTER_GUARDFEMALE1")
mod:registerAssetId("models/Security1.fbx/Prefab/CharacterPart/GuardMale", "PREFAB_SECURITY_CHARACTER_GUARDMALE1")

mod:registerAssetId("models/Security1.fbx/Prefab/CharacterPart/GuardFemale2", "PREFAB_SECURITY_CHARACTER_GUARDFEMALE2")
mod:registerAssetId("models/Security1.fbx/Prefab/CharacterPart/GuardMale2", "PREFAB_SECURITY_CHARACTER_GUARDMALE2")

mod:registerAssetId("models/Security1.fbx/Prefab/CharacterPart/ConstableFemale", "PREFAB_SECURITY_CHARACTER_CONSTABLEFEMALE1")
mod:registerAssetId("models/Security1.fbx/Prefab/CharacterPart/ConstableMale", "PREFAB_SECURITY_CHARACTER_CONSTABLEMALE1")

mod:registerAssetId("models/Security1.fbx/Prefab/CharacterPart/CrierFemale", "PREFAB_SECURITY_CHARACTER_CRIERFEMALE1")
mod:registerAssetId("models/Security1.fbx/Prefab/CharacterPart/CrierMale", "PREFAB_SECURITY_CHARACTER_CRIERMALE1")



-- Building Asset Processor
mod:registerAssetProcessor("models/Security1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Security2.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })




-- Grounding
-- mod:registerPrefabComponent("models/HighStreetBuilding1.fbx/Prefab/PlaceholderPart/Cube.001", {DataType = "COMP_GROUNDED"})



-- Collider Platform (climbable mesh)  -------------------------------------------------------------------------------------
mod:configurePrefabFlagList("models/Security2.fbx/Prefab/PlatformPart", { "PLATFORM" })



-- Manual paths for buyer and seller
mod:registerAssetId("models/Security2.fbx/Prefab/PlatformPart/PATH_A_1", "TOWNCRIER_PATHA1")
mod:registerAssetId("models/Security2.fbx/Prefab/PlatformPart/PATH_A_2", "TOWNCRIER_PATHA2")
mod:registerAssetId("models/Security2.fbx/Prefab/PlatformPart/PATH_B_1", "TOWNCRIER_PATHB1")
mod:registerAssetId("models/Security2.fbx/Prefab/PlatformPart/PATH_C_1", "TOWNCRIER_PATHC1")
mod:registerAssetId("models/Security2.fbx/Prefab/PlatformPart/PATH_D_1", "TOWNCRIER_PATHD1")
mod:registerAssetId("models/Security2.fbx/Prefab/PlatformPart/PATH_E_1", "TOWNCRIER_PATHE1")
mod:registerAssetId("models/Security2.fbx/Prefab/PlatformPart/PATH_F_1", "TOWNCRIER_PATHF1")

mod:registerPrefabComponent("models/Security2.fbx/Prefab/PlatformPart", {
    DataType = "COMP_BUILDING_PART",
    PathList = {
        {
            PathType = BUILDING_PATH_TYPE.DEFAULT,
            WayPointList = { "TOWNCRIER_PATHA1", "TOWNCRIER_PATHA2" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "TOWNCRIER_PATHB1" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "TOWNCRIER_PATHC1" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "TOWNCRIER_PATHD1" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "TOWNCRIER_PATHE1" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "TOWNCRIER_PATHF1" }
        },
    }
})


-- Resource Type  -------------------------------------------------------------------------------------
mod:registerEnumValue( "RESOURCE_TYPE", "RESOURCE_TYPE_SECURITY" )



-- Happiness factor -------------------------------------------------------------------------------------
mod:register({
    DataType = "HAPPINESS_FACTOR",
    Id = "HAPPINESS_FACTOR_SECURITY",
    Value = -2,
    IsDecaying = true,
    TimeBeforeDecayingSeconds = 120.0,
    DecayingRatePerMinute = 3.5,
    IsCumulative = true,
    IsSolvable = true,
    RemovedOnDecayed = false
})



-- Villager Need -------------------------------------------------------------------------------------
mod:register({
    DataType = "VILLAGER_NEED_TYPE",
    Id = "NEED_SECURITY",
    NeedTypeName = "NEED_SECURITY_NAME",
    NeedTypeList = {"RESOURCE_TYPE_SECURITY"},
    -- FillDurationInSeconds = (60 * 10), -- increased from 7 to 10 days for v1.0.1; in reality I'm observing this is about 8 days
    FillDurationInSeconds = 1000, -- increased from 600 to 1000 seconds for v1.0.3; this is now the same rhythm as for Fuel
    FillRate = 100,
    GracePeriod = 7,
    HappinessFactor = "HAPPINESS_FACTOR_SECURITY",
    ResourceTypeIcon = "ICON_SECURITY"
})

mod:override({
    Id = "SERF",
    AssetVillagerNeedList = {
        Action = "APPEND", "NEED_SECURITY"
    }
})



-- Resource: Security -------------------------------------------------------------------------------------
-- mod:registerAssetId("icons/Security.png", "ICON_SECURITY")

-- mod:register({
-- 	DataType = "RESOURCE",
-- 	Id = "RESOURCE_SECURITY",
-- 	ResourceName = "RESOURCE_SECURITY_NAME",
-- 	Icon = "ICON_SECURITY",
-- 	ResourceTypeList = { "RESOURCE_TYPE_SECURITY" },
-- 	IsTradable = false,
-- 	-- VillagerBuyingPrice = { Resource = "GOLD", Quantity = 1 },
--     DisplayInInventory = false,
--     DisplayInToolbar = true
--     -- ConsumptionBehaviorOverride = "BEHAVIOR_TREE_SECURITY_CONSUME"
-- })



-- Remove gold coins from inventory list
mod:override({
    Id = "GOLD_COINS",
    DisplayInInventory = false
})



-- Resource: Security Reports -------------------------------------------------------------------------------------
mod:registerAssetId("icons/Report.png", "ICON_REPORT")

mod:register({
	DataType = "RESOURCE",
	Id = "RESOURCE_REPORT",
	ResourceName = "RESOURCE_REPORT_NAME",
	Icon = "ICON_REPORT",
	ResourceTypeList = { "RESOURCE" },
	IsTradable = false,
	DisplayInInventory = false
})



-- Resource Container -------------------------------------------------------------------------------------
mod:registerPrefabComponent( "models/Security1.fbx/Prefab/PatrolPart/PatrolPoint", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "RESOURCE_REPORT",
    IsReplenishable = true,
	ReplenishDurationInDays = 7,
	ReplenishQuantity = 1,
    ResourceValue = 1.0, -- how many are gathered with each pick
    AvailableQuantity = 1, -- maximum container stock
    Radius = 0, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = false
    -- HasMaximumWorkstation = true -- not sure what this does, hoping it keeps them from using each other's patrol points
})



-- Plantable -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Security1.fbx/Prefab/PatrolPart/PatrolPoint", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 1.0 })

-- Building Part (required with plantables to prevent rare crash)
mod:registerPrefabComponent("models/Security1.fbx/Prefab/PatrolPart/PatrolPoint", { DataType = "COMP_BUILDING_PART" })




-- Building: Security -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING", 
	Id = "BUILDING_SECURITY_SECURITY",
	Name = "BUILDING_SECURITY_SECURITY_NAME",
	Description = "BUILDING_SECURITY_SECURITY_DESC",
	BuildingType = "MONUMENT",
    AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
	BuildingPartSetList = {
		{
			Name = "BUILDING_SET_SECURITY1_NAME",
			BuildingPartList = { 
				"BUILDING_PART_SECURITY_PATROLHUT1",
				"BUILDING_PART_SECURITY_PATROLPOINT1",
			}
		},
		{
			Name = "BUILDING_SET_SECURITY2_NAME",
			BuildingPartList = { 
                "BUILDING_PART_SECURITY_GUARDPOST1",
                -- "BUILDING_PART_SECURITY_GIANT_POST",
			}
		},
		-- {
		-- 	Name = "BUILDING_SET_SECURITY3_NAME",
		-- 	BuildingPartList = { 
		-- 	}
		-- },
		-- {
		-- 	Name = "BUILDING_SET_SECURITY4_NAME",
		-- 	BuildingPartList = { 
		-- 	}
		-- },
		{
			Name = "BUILDING_SET_SECURITY5_NAME",
			BuildingPartList = { 
				"BUILDING_PART_SECURITY_CRIER1",
			}
		},
    },
	-- RequiredPartList = {
	-- 	{ Category = "CORE", Min = 1, Max = 1 },
	-- },
	-- VillagerRequired = { Status = "SERF", Quantity = 10 },
	IsEditable = true
})



-- Building Part: Patrol Hut -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_SECURITY_PATROLHUT1",
	Name = "BUILDING_PART_SECURITY_PATROLHUT1_NAME", 
	Description = "BUILDING_PART_SECURITY_PATROLHUT1_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_SECURITY_PATROLHUT1"
	},
	ConstructionVisual = "PREFAB_CONSTR_SECURITY_PATROLHUT1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2.5, 2.5}, {0, -1.25} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_PATROL",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 10 } },
        UpkeepCost = { { Resource = "GOLD", Quantity = 10 } },
        RessourcesNeeded = {
            { Resource = "PLANK", Quantity = 2 },
		}
	}
})



-- Building Part: Patrol Point 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_SECURITY_PATROLPOINT1",
	Name = "BUILDING_PART_SECURITY_PATROLPOINT1_NAME", 
	Description = "BUILDING_PART_SECURITY_PATROLPOINT1_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_SECURITY_PATROLPOINT1"
	},
	BuildingZone = { 
	},
	IsVisibleWhenBuilt = false,
	IsMovableWhenBuilt = false
})




-- Building Part: Guard Post -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_SECURITY_GUARDPOST1",
    Name = "BUILDING_PART_SECURITY_GUARDPOST1_NAME", 
    Description = "BUILDING_PART_SECURITY_GUARDPOST1_DESC",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_SECURITY_GUARDPOINT1"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1, 1}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GUARD_POST",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 10 } },
        UpkeepCost = { { Resource = "GOLD", Quantity = 10 } },
        RessourcesNeeded = {
            -- { Resource = "PLANK", Quantity = 2 },
		}
	}, 
	IsVisibleWhenBuilt = false,
	IsMovableWhenBuilt = false
})



-- Building Part: Town Crier 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_SECURITY_CRIER1",
	Name = "BUILDING_PART_SECURITY_CRIER1_NAME", 
	Description = "BUILDING_PART_SECURITY_CRIER1_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_SECURITY_CRIER1"
	},
	ConstructionVisual = "PREFAB_CONSTR_SECURITY_CRIER1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1.1, 1.75}, {0, -0.25} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_CRIER",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 5 } },
        UpkeepCost = { { Resource = "GOLD", Quantity = 10 } },
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 1 },
		}
	},
	DesirabilityModifiers = { {
		Desirability = "DESIRABILITY_RESIDENTIAL",
		Type = "ADD",
		Radius = 15.0,
		Value = 0.5
	} } 
})



-- Add Town Crier to Frontier Fortifications -------------------------------------------------------------------------------------
mod:override({
	Id = "BUILDING_FRONTIER",
	BuildingPartSetList = {
        Action = "APPEND",
		{
			Name = "BUILDING_SET_SECURITY_CRIER1_NAME",
			BuildingPartList = { 
				"BUILDING_PART_SECURITY_CRIER1",
			}
		}
    }
})



-- Add Town Crier to Stone Gate Set -------------------------------------------------------------------------------------
mod:override({
	Id = "STONE_GATE_V7_MONUMENT",
	BuildingPartSetList = {
        Action = "APPEND",
		{
			Name = "BUILDING_SET_SECURITY_CRIER1_NAME",
			BuildingPartList = { 
				"BUILDING_PART_SECURITY_CRIER1",
			}
		}
    }
})



-- Add Town Crier to Lord Manor -------------------------------------------------------------------------------------
mod:override({
	Id = "MONUMENT_RUSTIC_LORD_MANOR",
	BuildingPartSetList = {
        Action = "APPEND",
		{
			Name = "BUILDING_SET_SECURITY_CRIER1_NAME",
			BuildingPartList = { 
				"BUILDING_PART_SECURITY_CRIER1",
			}
		}
    }
})



-- Add Town Crier to Wooden Keep -------------------------------------------------------------------------------------
mod:override({
	Id = "MONUMENT_WOODEN_KEEP",
	BuildingPartSetList = {
        Action = "APPEND",
		{
			Name = "BUILDING_SET_SECURITY_CRIER1_NAME",
			BuildingPartList = { 
				"BUILDING_PART_SECURITY_CRIER1",
			}
		}
    }
})




-- Job: Constable -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_SECURITY_CONSTABLE",
	JobName = "JOB_SECURITY_CONSTABLE_NAME",
	JobDescription = "JOB_SECURITY_CONSTABLE_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 10.0,
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
        DataType = "CHARACTER_SETUP",
        RightHandObject = {
			DataType = "HAND_OBJECT",
            Model = "PREFAB_TOOL_ENVOY_SCROLL"
        },
        MaleFrontList = {
        },
        FemaleHatList = {
            "PREFAB_SECURITY_CHARACTER_CONSTABLEFEMALE1"
        }, 
        MaleHatList = {
            "PREFAB_SECURITY_CHARACTER_CONSTABLEMALE1"
        }, 
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SECURITY_CONSTABLE"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SECURITY_CONSTABLE"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SECURITY_CONSTABLE"
    }
})

mod:override({
    Id = "CITIZEN",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SECURITY_CONSTABLE"
    }
})



-- Job: Guard (Tower) -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_SECURITY_GUARD_TOWER",
	JobName = "JOB_SECURITY_GUARD_TOWER_NAME",
	JobDescription = "JOB_SECURITY_GUARD_TOWER_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 30.0,
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        RightHandObject = {
			DataType = "HAND_OBJECT",
            Model = "PREFAB_TOOL_HUNTER_BOW"
        },
        FemaleHatList = {
            "PREFAB_SECURITY_CHARACTER_GUARDFEMALE1",
        }, 
        MaleHatList = {
            "PREFAB_SECURITY_CHARACTER_GUARDMALE1",
        }, 
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SECURITY_GUARD_TOWER"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SECURITY_GUARD_TOWER"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SECURITY_GUARD_TOWER"
    }
})



-- Job: Guard (Post) -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_SECURITY_GUARD_POST",
	JobName = "JOB_SECURITY_GUARD_POST_NAME",
	JobDescription = "JOB_SECURITY_GUARD_POST_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 30.0,
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        RightHandObject = {
			DataType = "HAND_OBJECT",
            Model = "PREFAB_TOOL_GUARD_SPEAR"
        },
        FemaleHatList = {
            "PREFAB_SECURITY_CHARACTER_GUARDFEMALE2",
        }, 
        MaleHatList = {
            "PREFAB_SECURITY_CHARACTER_GUARDMALE2",
        }, 
		WalkAnimation = "WALKING",
		IdleAnimation = "GUARD"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SECURITY_GUARD_POST"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SECURITY_GUARD_POST"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SECURITY_GUARD_POST"
    }
})



-- Job: Patrol -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_SECURITY_PATROL",
	JobName = "JOB_SECURITY_PATROL_NAME",
	JobDescription = "JOB_SECURITY_PATROL_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_GATHER",
    ProductionDelay = 30.0,
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        RightHandObject = {
			DataType = "HAND_OBJECT",
            Model = "PREFAB_TOOL_GUARD_SPEAR"
        },
        FemaleHatList = {
            "PREFAB_SECURITY_CHARACTER_PATROLFEMALE1",
        }, 
        MaleHatList = {
            "PREFAB_SECURITY_CHARACTER_PATROLMALE1",
        }, 
		WalkAnimation = "WALKING",
		IdleAnimation = "GUARD"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SECURITY_PATROL"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SECURITY_PATROL"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SECURITY_PATROL"
    }
})



-- Job: Town Crier -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_SECURITY_CRIER",
	JobName = "JOB_SECURITY_CRIER_NAME",
	JobDescription = "JOB_SECURITY_CRIER_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_MARKET_TENDING",
    ProductionDelay = 10.0,
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        -- RightHandObject = {
		-- 	DataType = "HAND_OBJECT",
        --     Model = "PREFAB_TOOL_GUARD_SPEAR"
        -- },
        FemaleHatList = {
            "PREFAB_SECURITY_CHARACTER_CRIERFEMALE1",
        }, 
        MaleHatList = {
            "PREFAB_SECURITY_CHARACTER_CRIERMALE1",
        }, 
		WalkAnimation = "WALKING",
		IdleAnimation = "MARKET_TENDER"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SECURITY_CRIER"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SECURITY_CRIER"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SECURITY_CRIER"
    }
})

mod:override({
    Id = "CITIZEN",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SECURITY_CRIER"
    }
})



-- Building Function: Patrol -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_SECURITY_PATROL",
    Name = "BUILDING_FUNCTION_SECURITY_PATROL_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_SECURITY_PATROL", 
        Behavior = "BEHAVIOR_GATHER"
    },
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_REPORT", Quantity = 1 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_REPORT", Quantity = 1 }, 
	},
	ResourceProduced = {
        { Resource = "RESOURCE_REPORT", Quantity = 1 },
    }
})



-- Building Function: Constabulary -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_SECURITY_CONSTABLE",
    Name = "BUILDING_FUNCTION_SECURITY_CONSTABLE_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_SECURITY_CONSTABLE", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_REPORT", Quantity = 50 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_REPORT", Quantity = 5 }, 
	},
	ResourceProduced = {
        { Resource = "RESOURCE_SECURITY", Quantity = 5 },
    }
})



-- Override Keep with building function (Frontier Fortifications) -------------------------------------------------------------------------------------
mod:override({
	Id = "BUILDING_PART_FRONTIER_KEEP1",
	AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_LORD_MANOR"
})



-- Add Constabulary building function to the Lord Manor function list -------------------------------------------------------------------------------------
mod:override({
    Id = "BUILDING_FUNCTION_LIST_LORD_MANOR",
    AssetFunctionList = {
        Action = "APPEND",
        "BUILDING_FUNCTION_SECURITY_CONSTABLE"
    }
})



-- Add Constabulary building function to the Keep function list -------------------------------------------------------------------------------------
mod:override({
    Id = "BUILDING_FUNCTION_LIST_KEEP",
    AssetFunctionList = {
        Action = "APPEND",
        "BUILDING_FUNCTION_SECURITY_CONSTABLE"
    }
})



-- Building Function: Town Crier -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_SECURITY_CRIER",
    Name = "BUILDING_FUNCTION_SECURITY_CRIER_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_SECURITY_CRIER", 
        Behavior = "BEHAVIOR_WORK"
	},
	TypeList = {
		"RESOURCE_TYPE_SECURITY",
	},
	IsOverrideCapacity = true,
	CapacityPerSlot = 50,
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_SECURITY", Quantity = 50 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_SECURITY", Quantity = 5 }, 
	},
	ResourceProduced = {
        { Resource = "RESOURCE_SECURITY", Quantity = 5 },
    }
})



-- Building Function: Guard Tower 1 (open) -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_SECURITY_GUARD_TOWER1",
    Name = "BUILDING_FUNCTION_SECURITY_GUARD_TOWER1_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_SECURITY_GUARD_TOWER", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
	},
    ResourceListNeeded = {
	},
	ResourceProduced = {
        { Resource = "RESOURCE_REPORT", Quantity = 1 },
    }
})



-- Building Function: Guard Tower 2 (enclosed) -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_SECURITY_GUARD_TOWER2",
    Name = "BUILDING_FUNCTION_SECURITY_GUARD_TOWER2_NAME",
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "JOB_SECURITY_GUARD_TOWER", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
	},
    ResourceListNeeded = {
	},
	ResourceProduced = {
        { Resource = "RESOURCE_REPORT", Quantity = 2 },
    }
})



-- Building Function: Guard Post -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_SECURITY_GUARD_POST",
    Name = "BUILDING_FUNCTION_SECURITY_GUARD_POST_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_SECURITY_GUARD_POST", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
	},
    ResourceListNeeded = {
	},
	ResourceProduced = {
        { Resource = "RESOURCE_REPORT", Quantity = 1 },
    }
})



-- Building Function List: Tower 2 -------------------------------------------------------------------------------------
-- This will override the functions currently placed on Towers, to disallow the Constable to be placed in a tower
-- Without mods, the towers have the same functions as the Lord Manor
mod:register({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = "BUILDING_FUNCTION_LIST_SECURITY_TOWER",
    AssetFunctionList = {
        -- "BUILDING_FUNCTION_GREAT_HALL",
        "BUILDING_FUNCTION_TREASURY",
        -- "BUILDING_FUNCTION_TAX_OFFICE",
        -- "BUILDING_FUNCTION_BAILIFF_OFFICE",
        "BUILDING_FUNCTION_SECURITY_GUARD_TOWER2",
    }
})



-- Building Function Assignable: Tower -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
    Id = "BUILDING_FUNCTION_ASSIGNABLE_SECURITY_TOWER",
    AuthorizedFunctionList = "BUILDING_FUNCTION_LIST_SECURITY_TOWER"
})



-- Override Towers and Gates with Guard building function -------------------------------------------------------------------------------------
mod:override({
	Id = "BUILDING_PART_FRONTIER_TOWER1",
	AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GUARD_TOWER1"
})

mod:override({
	Id = "BUILDING_PART_FRONTIER_TOWER2",
	AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GUARD_TOWER1"
})

mod:override({
	Id = "BUILDING_PART_FRONTIER_GATE1",
	AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GUARD_TOWER1"
})

mod:override({
	Id = "BUILDING_PART_FRONTIER_GATE4",
	AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GUARD_TOWER1"
})



-- Override other enclosed towers with full function list -------------------------------------------------------------------------------------
mod:override({
    Id = "BUILDING_PART_GATE_ROUND_TOWER",
    AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_SECURITY_TOWER"
})

mod:override({
    Id = "BUILDING_PART_GATE_ROUND_WATCHTOWER",
    AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_SECURITY_TOWER"
})

mod:override({
    Id = "BUILDING_PART_GATE_TOWER",
    AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_SECURITY_TOWER"
})

mod:override({
    Id = "BUILDING_PART_GATE_WATCHTOWER",
    AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_SECURITY_TOWER"
})



-- Stone Gate Set V7

mod:override({
    Id = "STONE_GATE_V7_FUNCTION_LIST",
    AssetFunctionList = {
        Action = "APPEND",
        "BUILDING_FUNCTION_SECURITY_CONSTABLE",
        "BUILDING_FUNCTION_SECURITY_GUARD_TOWER2",
    }
})



-- -- Custom Component: Patrol Hut -------------------------------------------------------------------------------------

-- local COMP_SECURITY_PATROLHUT = {
-- 	TypeName = "COMP_SECURITY_PATROLHUT",
-- 	ParentType = "COMP_WORKPLACE",
-- 	Properties = {
-- 		-- {
--         --     Name = "SeasonCurrent",
--         --     Type = "string",
--         --     Default = "Spring",
--         --     Flags = { "SAVE_GAME" } -- required to keep this value in saved games, allowing it to be reloaded when the game is loaded
--         -- },
--     }
-- }


-- function COMP_SECURITY_PATROLHUT:init()

--     mod:log("COMP_SECURITY_PATROLHUT initialising ______________________________________________________________________________________")

--     -- List all game objects and components for testing purposes
--     self:getOwner():getParent():getParent():forEachChildRecursive(function(object)
--         mod:log(tostring(object))        
--         object:forEachComponent(function(comp)
--             mod:log("   " .. tostring(comp))
--         end)
--     end)

-- 	event.register(self, self:getOwner().ON_WORKPLACE_PRODUCED, function()

-- 		mod:log("COMP_SECURITY_PATROLHUT setting container stock")

-- 	end)

-- end


-- mod:registerClass(COMP_SECURITY_PATROLHUT)


-- mod:registerPrefabComponent("models/Security1.fbx/Prefab/HutPart", { DataType = "COMP_BUILDING_PART" })
-- mod:registerPrefabComponent("models/Security1.fbx/Prefab/HutPart", { DataType = "COMP_SECURITY_PATROLHUT" })

